'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var as = require('./as-5f995f6c.js');
var Base = require('./Base.js');
var __chunk_1 = require('./chunk-c628ddbd.js');
var ReactDOM = require('react-dom');
var ReactDOM__default = _interopDefault(ReactDOM);
var __chunk_3 = require('./chunk-c7f60f29.js');
require('lodash/uniq');
require('react-known-props');
require('lodash/omit');
require('./chunk-7e606c56.js');
require('lodash/kebabCase');

var Component = function Component(props) {
  return React.createElement(Base.default, as._extends({
    "aria-orientation": props.vertical ? "vertical" : "horizontal"
  }, props));
};

var Toolbar = styled__default(Component).withConfig({
  displayName: "Toolbar"
})(["position:relative;display:grid;width:100%;padding:", ";grid-gap:", ";grid-template:\"start center end\" / 1fr auto 1fr;&[aria-orientation=\"vertical\"]{width:min-content;height:100%;grid-template:\"start\" 1fr \"center\" auto \"end\" 1fr;}", ";"], styledTools.withProp("gutter", __chunk_1.numberToPx), styledTools.withProp("gutter", __chunk_1.numberToPx), styledTools.prop("theme.Toolbar"));

Toolbar.propTypes = {
  gutter: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  vertical: PropTypes.bool
};

Toolbar.defaultProps = {
  role: "toolbar",
  gutter: 8
};

var Toolbar$1 = as.as("div")(Toolbar);

var Component$1 = function (_React$Component) {
  as.inherits(Component, _React$Component);

  function Component(props) {
    as.classCallCheck(this, Component);

    var _this = as.possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.getInitialTabIndex = function () {
      var tabIndex = _this.props.tabIndex;

      return typeof tabIndex !== "undefined" ? tabIndex : -1;
    };

    _this.getElement = function () {
      if (typeof _this.element === "undefined") {
        _this.element = ReactDOM.findDOMNode(_this);
      }
      return _this.element;
    };

    _this.getToolbar = function () {
      if (typeof _this.toolbar === "undefined") {
        _this.toolbar = _this.getElement().closest("." + Toolbar$1.styledComponentId);
      }
      return _this.toolbar;
    };

    _this.getFocusables = function () {
      if (!_this.getToolbar()) return [];
      return _this.getToolbar().querySelectorAll("." + ToolbarFocusable.styledComponentId);
    };

    _this.getCurrentIndex = function (focusables) {
      var currentIndex = -1;
      focusables.forEach(function (item, i) {
        if (item === _this.getElement()) {
          currentIndex = i;
        }
      });
      return currentIndex;
    };

    _this.getNextFocusable = function (focusables, currentIndex) {
      var index = currentIndex + 1;
      return focusables.item(index) || focusables.item(0);
    };

    _this.getPreviousFocusable = function (focusables, currentIndex) {
      var index = currentIndex ? currentIndex - 1 : focusables.length - 1;
      return focusables.item(index);
    };

    _this.toolbarIsVertical = function () {
      if (!_this.getToolbar()) return false;
      return _this.getToolbar().getAttribute("aria-orientation") === "vertical";
    };

    _this.addKeyDownHandler = function () {
      if (!_this.getToolbar()) return;
      _this.getElement().addEventListener("keydown", _this.handleKeyDown);
    };

    _this.removeKeyDownHandler = function () {
      if (!_this.getToolbar()) return;
      _this.getElement().removeEventListener("keydown", _this.handleKeyDown);
    };

    _this.handleKeyDown = function (e) {
      var isVertical = _this.toolbarIsVertical();
      var nextKey = isVertical ? "ArrowDown" : "ArrowRight";
      var previousKey = isVertical ? "ArrowUp" : "ArrowLeft";
      var willPerformEvent = [nextKey, previousKey].indexOf(e.key) >= 0;

      if (!willPerformEvent) return;

      var focusables = _this.getFocusables();
      var currentIndex = _this.getCurrentIndex(focusables);

      e.preventDefault();
      _this.setState({ tabIndex: _this.getInitialTabIndex() });

      if (e.key === nextKey) {
        _this.getNextFocusable(focusables, currentIndex).focus();
      } else {
        _this.getPreviousFocusable(focusables, currentIndex).focus();
      }
    };

    _this.handleFocus = function () {
      _this.setState({ tabIndex: 0 });
    };

    _this.state = {
      tabIndex: _this.getInitialTabIndex()
    };
    return _this;
  }

  Component.prototype.componentDidMount = function componentDidMount() {
    if (this.getCurrentIndex(this.getFocusables()) === 0) {
      this.setState({ tabIndex: 0 });
    }

    if (!this.props.disabled) {
      this.addKeyDownHandler();
    }
  };

  Component.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    var disabled = this.props.disabled;


    if (prevProps.disabled !== disabled) {
      if (disabled) {
        this.removeKeyDownHandler();
      } else {
        this.addKeyDownHandler();
      }
    }
  };

  Component.prototype.componentWillUnmount = function componentWillUnmount() {
    this.removeKeyDownHandler();
  };

  Component.prototype.render = function render() {
    return React.createElement(Base.default, as._extends({}, this.props, {
      onFocus: __chunk_3.callAll(this.handleFocus, this.props.onFocus),
      tabIndex: this.state.tabIndex
    }));
  };

  return Component;
}(React.Component);

Component$1.propTypes = {
  tabIndex: PropTypes.number,
  onFocus: PropTypes.func,
  disabled: PropTypes.bool
};


var ToolbarFocusable = styled__default(Component$1).withConfig({
  displayName: "ToolbarFocusable"
})(["", ";"], styledTools.prop("theme.ToolbarFocusable"));

var ToolbarFocusable$1 = as.as("div")(ToolbarFocusable);

var ToolbarContent = styled__default(Base.default).withConfig({
  displayName: "ToolbarContent"
})(["display:grid;grid-auto-flow:column;grid-auto-columns:min-content;grid-gap:inherit;grid-area:", ";justify-content:", ";align-items:center;[aria-orientation=\"vertical\"] > &{grid-auto-flow:row;grid-auto-rows:min-content;justify-content:initial;align-content:", ";}", ";"], styledTools.prop("align"), styledTools.prop("align"), styledTools.prop("align"), styledTools.prop("theme.ToolbarContent"));

ToolbarContent.propTypes = {
  align: PropTypes.oneOf(["start", "center", "end"])
};

ToolbarContent.defaultProps = {
  align: "start"
};

var ToolbarContent$1 = as.as("div")(ToolbarContent);

Toolbar$1.Focusable = ToolbarFocusable$1;
Toolbar$1.Content = ToolbarContent$1;

exports.default = Toolbar$1;
